unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Menus,
  StdCtrls, Buttons, ExtCtrls, Process, CommDlg, Windows, Messages, jwaTlHelp32, Unit2, Unit3;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    MainMenu1: TMainMenu;
    Memo1: TMemo;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem15: TMenuItem;
    MenuItem16: TMenuItem;
    MenuItem17: TMenuItem;
    MenuItem18: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    OpenDialog1: TOpenDialog;
    OpenDialog2: TOpenDialog;
    StaticText1: TStaticText;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDropFiles(Sender: TObject; const FileNames: array of string);
    procedure MenuItem10Click(Sender: TObject);
    procedure MenuItem12Click(Sender: TObject);
    procedure MenuItem14Click(Sender: TObject);
    procedure MenuItem15Click(Sender: TObject);
    procedure MenuItem16Click(Sender: TObject);
    procedure MenuItem17Click(Sender: TObject);
    procedure MenuItem18Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure MenuItem4Click(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MenuItem6Click(Sender: TObject);
    procedure MenuItem8Click(Sender: TObject);
    procedure MenuItem9Click(Sender: TObject);
    procedure ModifySF(sf: string);
    procedure play;
    procedure stop;
    procedure delay(msecs: integer);
    function RefreshList: boolean;
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  pdf, aaa: boolean;
  filename: string;
  hw: hwnd;

implementation

{$R *.lfm}

{ TForm1 }
function TForm1.RefreshList: boolean;
var
  ProcessName: string;
  ProcessID: integer;
  Pubstr: string;
  ContinueLoop: boolean;
  FSnapshotHandle: THandle;
  FProcessEntry32: TProcessEntry32;
begin
  FSnapshotHandle := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
  FProcessEntry32.dwSize := Sizeof(FProcessEntry32);
  ContinueLoop := Process32First(FSnapshotHandle, FProcessEntry32);
  while ContinueLoop do
  begin
    ProcessName := FProcessEntry32.szExeFile;
    ProcessID := FProcessEntry32.th32ProcessID;
    //Listbox1.Items.add(''+ProcessName +''+ inttostr(ProcessID));
    if ProcessName = 'timidity.exe' then
      exit(True);
    //pubstr:=ProcessName+makespace(20-length(ProcessName))+inttostr(ProcessID);
    ContinueLoop := Process32Next(FSnapshotHandle, FProcessEntry32);
  end;
  exit(False);
end;


procedure TForm1.Delay(msecs: integer);
var
  Tick: DWord;
  Event: THandle;
begin
  Event := CreateEvent(nil, False, False, nil);
  try
    Tick := GetTickCount + DWord(msecs);
    while (msecs > 0) and (MsgWaitForMultipleObjects(1, Event, False,
        msecs, QS_ALLINPUT) <> WAIT_TIMEOUT) do
    begin
      Application.ProcessMessages;
      msecs := Tick - GetTickCount;
    end;
  finally
    CloseHandle(Event);
  end;
end;

procedure TForm1.play;
var
  proc: TProcess;
  pth: string;
  p: PChar;
begin
  pth := ExtractFilePath(ParamStr(0));
  p := PChar(pth + 'timidity.exe "' + filename + '" -Od');
  proc := TProcess.Create(nil);
  proc.CommandLine := p;
  proc.Options := proc.Options + [poNoConsole, poUsePipes];
  proc.Execute;
  delay(500);
  Memo1.Lines.LoadFromStream(proc.Output);
  while RefreshList do
  begin
    delay(100);
  end;
  proc.Free;
end;

procedure TForm1.stop;
var
  proc: TProcess;
  p: PChar;
begin
  p := PChar('taskkill.exe /f /im timidity.exe');
  proc := TProcess.Create(nil);
  proc.CommandLine := p;
  proc.Options := [poNoConsole];
  proc.Execute;
  proc.Free;
  if MenuItem17.Checked then
  begin
    MenuItem17.Checked := False;
  end;
end;

procedure TForm1.FormDropFiles(Sender: TObject; const FileNames: array of string);
begin
  filename := FileNames[0];
  StaticText1.Caption := filename;
  StaticText1.Hint := filename;
  Button1.Enabled := True;
  Button2.Enabled := False;
  Button3.Enabled := True;
  MenuItem12.Enabled := True;
  if not pdf then
    exit;
  if RefreshList then
  begin
    stop;
    delay(500);
  end;
  Button2.Enabled := True;
  Button1.Enabled := False;
  play;
  Button1.Enabled := True;
  Button2.Enabled := False;
end;

procedure TForm1.MenuItem10Click(Sender: TObject);
var
  sfn, ts: string;
begin
  OpenDialog2.Execute;
  sfn := OpenDialog2.FileName;
  ts := copy(sfn, length(sfn) - 3, 4);
  if ts <> '.sf2' then
    exit;
  ModifySF(sfn);
  MenuItem8.Checked := False;
  MenuItem9.Checked := False;
  MenuItem11.Checked := True;
  MenuItem11.Enabled := True;
  MenuItem18.Checked := False;
  MenuItem11.Caption := 'Custom SoundFont: ' + sfn;
end;

procedure TForm1.MenuItem12Click(Sender: TObject);
var
  pth: string;
  p: PChar;
  proc: TProcess;
begin
  Button3.Enabled := False;
  Button3.Caption := 'Converting...';
  MenuItem12.Enabled := False;
  pth := ExtractFilePath(ParamStr(0));
  p := PChar(pth + 'timidity.exe "' + filename + '" -Ow');
  proc := TProcess.Create(nil);
  proc.CommandLine := p;
  proc.Options := [poNoConsole, poUsePipes];
  proc.Execute;
  delay(500);
  Memo1.Lines.LoadFromStream(proc.Output);
  proc.Free;
  while RefreshList do
    delay(100);
  Button3.Caption := 'Convert to Wav';
  Button3.Enabled := True;
  MenuItem12.Enabled := True;
end;

procedure TForm1.MenuItem14Click(Sender: TObject);
var
  hc: ansistring;
begin
  hc := 'Chrisoft Timidity Player Help' + #10;
  hc := hc + 'You can open a file by dropping a file into this application or use File-Open.'
    + #10;
  hc := hc + 'Then you can play it or convert it to a wave file.' + #10;
  hc := hc + 'The wave file output folder is the same as the source file folder.' +
    #10 + #10;
  hc := hc + 'The player supports SoundFont Technology.' + #10;
  hc := hc + 'You can change the SoundFont used by the player by using the SoundFont Menu.'
    + #10;
  Application.MessageBox(PChar(hc), 'Chrisoft Timidity Player Help', 0);
end;

procedure TForm1.MenuItem15Click(Sender: TObject);
begin
  Form3.Show;
end;

procedure TForm1.MenuItem16Click(Sender: TObject);
var
  i: longint;
begin
  if not MenuItem16.Checked then
  begin
    MenuItem16.Checked := True;
    i := 155;
    while i <= 430 do
    begin
      Form1.Height := i;
      Inc(i, 5);
      delay(1);
    end;
  end
  else
  begin
    MenuItem16.Checked := False;
    i := 430;
    while i >= 155 do
    begin
      Form1.Height := i;
      Dec(i, 5);
      delay(1);
    end;
  end;
end;

procedure TForm1.MenuItem17Click(Sender: TObject);
begin
  MenuItem17.Checked := not MenuItem17.Checked;
  aaa := not aaa;
end;

procedure TForm1.MenuItem18Click(Sender: TObject);
begin
  MenuItem8.Checked := False;
  MenuItem9.Checked := False;
  MenuItem11.Checked := False;
  Form2.Visible := True;
end;

procedure TForm1.ModifySF(sf: string);
var
  ttext: Text;
begin
  assignfile(ttext, 'timidity.cfg');
  rewrite(ttext);
  writeln(ttext, 'dir .');
  writeln(ttext, 'dir .');
  writeln(ttext);
  writeln(ttext, 'soundfont ', sf);
  writeln(ttext);
  closefile(ttext);
end;

procedure TForm1.MenuItem2Click(Sender: TObject);
var
  ts: string;
begin
  OpenDialog1.Execute;
  filename := OpenDialog1.FileName;
  ts := copy(filename, length(filename) - 3, 4);
  if ts <> '.mid' then
    exit;
  StaticText1.Caption := filename;
  StaticText1.Hint := filename;
  Button1.Enabled := True;
  Button3.Enabled := True;
  MenuItem12.Enabled := True;
end;

procedure TForm1.MenuItem3Click(Sender: TObject);
begin
  if RefreshList then
  begin
    stop;
    delay(500);
  end;
  Button2.Enabled := True;
  MenuItem4.Enabled := True;
  Button1.Enabled := False;
  MenuItem3.Enabled := False;
  play;
  while MenuItem17.Checked do
    play;
  Button1.Enabled := True;
  MenuItem3.Enabled := True;
  Button2.Enabled := False;
  MenuItem4.Enabled := False;
  if aaa then
    MenuItem17.Checked := True;
end;

procedure TForm1.MenuItem4Click(Sender: TObject);
begin
  Button1.Enabled := True;
  MenuItem3.Enabled := True;
  Button2.Enabled := False;
  MenuItem4.Enabled := False;
  stop;
end;

procedure TForm1.MenuItem5Click(Sender: TObject);
begin
  if MenuItem5.Checked then
  begin
    pdf := False;
    MenuItem5.Checked := False;
  end
  else
  begin
    pdf := True;
    MenuItem5.Checked := True;
  end;
end;

procedure TForm1.MenuItem6Click(Sender: TObject);
begin
  stop;
  Application.Terminate;
end;

procedure TForm1.MenuItem8Click(Sender: TObject);
begin
  ModifySF('MicrosoftGS.sf2');
  MenuItem8.Checked := True;
  MenuItem9.Checked := False;
  MenuItem11.Checked := False;
  MenuItem11.Enabled := False;
  MenuItem18.Checked := False;
  MenuItem11.Caption := 'Custom SoundFont';
end;

procedure TForm1.MenuItem9Click(Sender: TObject);
begin
  ModifySF('TimGM6mb.sf2');
  MenuItem8.Checked := False;
  MenuItem9.Checked := True;
  MenuItem11.Checked := False;
  MenuItem11.Enabled := False;
  MenuItem18.Checked := False;
  MenuItem11.Caption := 'Custom SoundFont';
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  ttext: Text;
  ts: string;
begin
  pdf := False;
  aaa := False;
  assignfile(ttext, 'timidity.cfg');
  reset(ttext);
  readln(ttext, ts);
  readln(ttext, ts);
  readln(ttext, ts);
  readln(ttext, ts);
  case ts of
    'soundfont MicrosoftGS.sf2':
    begin
      MenuItem8.Checked := True;
      MenuItem9.Checked := False;
      MenuItem11.Checked := False;
      MenuItem11.Enabled := False;
      MenuItem18.Checked := False;
    end;
    'soundfont TimGM6mb.sf2':
    begin
      MenuItem8.Checked := False;
      MenuItem9.Checked := True;
      MenuItem11.Checked := False;
      MenuItem11.Enabled := False;
      MenuItem18.Checked := False;
    end;
    else
    begin
      MenuItem8.Checked := False;
      MenuItem9.Checked := False;
      MenuItem11.Checked := True;
      MenuItem11.Enabled := True;
      MenuItem18.Checked := False;
      Delete(ts, 1, 10);
      MenuItem11.Caption := 'Custom SoundFont: ' + ts;
    end;
  end;
  while not EOF(ttext) do
  begin
    readln(ttext, ts);
    if copy(ts, 1, 9) = 'soundfont' then
    begin
      MenuItem8.Checked := False;
      MenuItem9.Checked := False;
      MenuItem11.Checked := False;
      MenuItem11.Enabled := False;
      MenuItem18.Checked := True;
      MenuItem11.Caption := 'Custom SoundFont';
    end;
  end;
  closefile(ttext);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if RefreshList then
  begin
    stop;
    delay(500);
  end;
  Button2.Enabled := True;
  MenuItem4.Enabled := True;
  Button1.Enabled := False;
  MenuItem3.Enabled := False;
  play;
  while MenuItem17.Checked do
    play;
  Button1.Enabled := True;
  MenuItem3.Enabled := True;
  Button2.Enabled := False;
  MenuItem4.Enabled := False;
  if aaa then
    MenuItem17.Checked := True;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Button1.Enabled := True;
  MenuItem3.Enabled := True;
  Button2.Enabled := False;
  MenuItem4.Enabled := False;
  stop;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  pth: string;
  p: PChar;
  proc: TProcess;
begin
  Button3.Enabled := False;
  Button3.Caption := 'Converting...';
  MenuItem12.Enabled := False;
  pth := ExtractFilePath(ParamStr(0));
  p := PChar(pth + 'timidity.exe "' + filename + '" -Ow');
  proc := TProcess.Create(nil);
  proc.CommandLine := p;
  proc.Options := [poNoConsole];
  proc.Execute;
  proc.Free;
  while RefreshList do
    delay(100);
  Button3.Caption := 'Convert to Wav';
  Button3.Enabled := True;
  MenuItem12.Enabled := True;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  stop;
end;


end.
